proc new_group_request { group reload } {
	global C_GROUP C_HOST
	global  GR_${group}_Master
	if { $C_GROUP == $group && !$reload} {
		.status.lbl configure -text "Allready in this Group."
		return 0
		}

	.groups configure -cursor watch
#	.status.foo configure -text "BUSY"
	SetStatus "+BUSY"

	.remote configure -state normal
	.remote delete 1.1 end
	.remote configure -state disabled

	.hosts configure -state normal
	.hosts delete 1.1 end
	global GR_${group}_List
	foreach host [set GR_${group}_List] {
		if { $host != "" } {
			.hosts insert end $host item
			.hosts insert end " \n "
			}
		}
	.hosts configure -state disabled

	.shares configure -state normal
	.shares delete 1.1 end
#	set C_HOST [set GR_${group}_Master ]
#	set C_GROUP $group
	set_current C_HOST  .hosts  [set GR_${group}_Master ]
	set_current C_GROUP .groups $group

#	.trt4 configure -text $C_HOST
#	.trt6 configure -text $C_GROUP
	global UC_HOST UC_GROUP
	set UC_HOST  $C_HOST
	set UC_GROUP $C_GROUP
	global H_${C_HOST}_Shares
	global H_${C_HOST}_Browse
	if {[def H_${C_HOST}_Shares]} {
		foreach share [set H_${C_HOST}_Shares] {
			if { $share != ""} {
				.shares insert end $share item
				.shares insert end " \n "
				}
			}
		}
	if { [set H_${C_HOST}_Browse] == "failed" &&!$reload} {
		.shares insert end "<FAILED>"
		}
	.shares configure -state disabled

	set brz [ set H_${C_HOST}_Browse ]
	if { $brz == "host" || $brz == "no" || $reload } {
		viewhost $C_HOST $C_GROUP 0
		}
#	.status.foo configure -text ""
	SetStatus "-BUSY"
	.groups configure -cursor hand2
	}

proc new_host_request { host reload } {
global C_HOST C_GROUP
if { $C_HOST == $host && !$reload} {
	.status.lbl configure -text "Allready in this Host."
	return 0
	}
global H_${host}_Shares
global H_${host}_Browse
#.status.foo configure -text "BUSY"
SetStatus "+BUSY"
.hosts configure -cursor watch

.remote configure -state normal
.remote delete 1.1 end
.remote configure -state disabled

.shares configure -state normal
.shares delete 1.1 end
set_current C_HOST .hosts $host
#.trt4 configure -text $host
#.trt6 configure -text $C_GROUP
global UC_HOST UC_GROUP
set UC_HOST  $C_HOST
set UC_GROUP $C_GROUP
if {[def H_${host}_Shares]} {
	foreach share [set H_${host}_Shares] {
		if { $share != ""} {
			.shares insert end $share item
			.shares insert end " \n "
			}
		}
	}
if { [set H_${C_HOST}_Browse] == "failed" && !$reload} {
	.shares insert end "<FAILED>"
	}
.shares configure -state disabled
if { [ set H_${host}_Browse ] == "no" || $reload } {
        viewhost $host $C_GROUP 0
        }
#.status.foo configure -text ""
SetStatus "-BUSY"

.hosts configure -cursor hand2

}

proc nmblookup_simple { host serv } {
	if { $serv == "" || $serv == "No" } {spawn -nottyinit nmblookup $host} else {spawn -nottyinit nmblookup $host -B $serv}
	set id $spawn_id
	expect {
		 -i $id     "failed" {
			close -i $id
			wait  -i $id
			puts "ip not known"
			return "" 
			}
		 -i $id -re "(\[^\n\]*) $host" {
			puts $expect_out(1,string)
			close -i $id
			wait  -i $id
			puts "ip is $expect_out(1,string)"
			return $expect_out(1,string)
			}
		}
	close -i $id
	wait  -i $id
	return {}
	}

proc nmblookup { host } {
global H_${host}_IP
defifndef H_${host}_IP ""
set ip [set H_${host}_IP]
if {$ip == "No"} {return ""}
if {$ip != ""} {return $ip}

global BROADCAST
set ip [nmblookup_simple $host $BROADCAST]
if { $ip != ""} {
	set H_${host}_IP $ip
	return $ip
	}
catch {
	global C_GROUP
	global GR_${C_GROUP}_Master
	set master [set GR_${C_GROUP}_Master]
	global H_${master}_IP
	set gip [set H_${master}_IP]
	set ip [nmblookup_simple $host $gip]
	}
set H_${host}_IP $ip
if { $ip == "" } { set H_${host}_IP "No" }
return $ip
}

proc host_ping_request { host } {
	puts "pinging $host...."
	nmblookup $host
	}


proc password { msg } {
	global font spawn_id
        toplevel .pass
        label .pass.l -text "$msg" -font $font
        entry .pass.foo -font $font -textvariable password
        wm geometry .pass 300x50
        pack .pass.l   -side top -fill x
        pack .pass.foo -side top -fill x
	bind .pass.foo <Return> {
        	exp_send "$password\r"
		destroy .pass
		}

}

proc mount { host share } {
global H_${host}_IP username spawn_id PASSWORD
set ip [set H_${host}_IP]
catch { exec mkdir /tmp/_${host}_$share }
if {$ip == ""} {
spawn smbmount //$host/$share
} else {
spawn smbmount //$host/$share -I $ip
}
set id $spawn_id
expect {
	-i $id "assword" {
		#password "Enter Password"
		exp_send "$PASSWORD\r"
		exp_continue
		puts Waiting...
		}
	-i $id "smb:" {
		#password "Enter Password"
		exp_send "mount /tmp/_${host}_$share\r"
		exp_continue
		puts Waiting...
		}
	}
	disconnect 
	#wait -i $id
	puts Terminated
}
